// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef IPC_IPC_MOJOM_INTERNAL_H_
#define IPC_IPC_MOJOM_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/lib/union_accessor.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace IPC {
namespace mojom {

class SerializedHandle;


namespace internal {

class SerializedHandle_Data;




#pragma pack(push, 1)


class SerializedHandle_Data {
 public:
  static SerializedHandle_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void EncodePointers();
  void DecodePointers();


  
  struct Type_Data {
   public:
    static bool const kIsExtensible = false;
  
    static bool IsKnownValue(int32_t value) {
      switch (value) {
        case 0:
        case 1:
        case 2:
        case 3:
          return true;
      }
      return false;
    }
  
    static bool Validate(int32_t value,
                         mojo::internal::ValidationContext* validation_context) {
      if (kIsExtensible || IsKnownValue(value))
        return true;
  
      ReportValidationError(validation_context,
                            mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
      return false;
    }
  };

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data the_handle;
  int32_t type;

 private:
  SerializedHandle_Data();
  ~SerializedHandle_Data() = delete;
};
static_assert(sizeof(SerializedHandle_Data) == 16,
              "Bad sizeof(SerializedHandle_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace IPC

#endif  // IPC_IPC_MOJOM_INTERNAL_H_