// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "ipc/ipc.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/trace_event/trace_event.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/message_builder.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
namespace IPC {
namespace mojom {

namespace internal {
namespace {

#pragma pack(push, 1)
const uint32_t kChannel_Receive_Name = 0;

class Channel_Receive_Params_Data {
 public:
  static Channel_Receive_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void EncodePointers();
  void DecodePointers();



  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> data;
  mojo::internal::Pointer<mojo::internal::Array_Data<internal::SerializedHandle_Data*>> handles;

 private:
  Channel_Receive_Params_Data();
  ~Channel_Receive_Params_Data() = delete;
};
static_assert(sizeof(Channel_Receive_Params_Data) == 24,
              "Bad sizeof(Channel_Receive_Params_Data)");

// static
Channel_Receive_Params_Data* Channel_Receive_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(Channel_Receive_Params_Data))) Channel_Receive_Params_Data();
}

// static
bool Channel_Receive_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Channel_Receive_Params_Data* object = static_cast<const Channel_Receive_Params_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->data, "null data field in Channel_Receive_Params",
          validation_context)) {
    return false;
  }
  const mojo::internal::ContainerValidateParams data_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateArray(object->data, validation_context,
                                     &data_validate_params)) {
    return false;
  }

  const mojo::internal::ContainerValidateParams handles_validate_params(
      0, false, nullptr);
  if (!mojo::internal::ValidateArray(object->handles, validation_context,
                                     &handles_validate_params)) {
    return false;
  }

  return true;
}

void Channel_Receive_Params_Data::EncodePointers() {
  CHECK(header_.version == 0);
  mojo::internal::Encode(&this->data);
  mojo::internal::Encode(&this->handles);
}

void Channel_Receive_Params_Data::DecodePointers() {
  // NOTE: The memory backing |this| may be smaller than |sizeof(*this)|, if the
  // message comes from an older version.
  mojo::internal::Decode(&this->data);
  mojo::internal::Decode(&this->handles);
}

Channel_Receive_Params_Data::Channel_Receive_Params_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}
const uint32_t kBootstrap_Init_Name = 0;

class Bootstrap_Init_Params_Data {
 public:
  static Bootstrap_Init_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void EncodePointers();
  void DecodePointers();



  mojo::internal::StructHeader header_;
  mojo::internal::AssociatedInterfaceRequest_Data to_client_channel;
  mojo::internal::AssociatedInterface_Data to_server_channel;
  int32_t pid;

 private:
  Bootstrap_Init_Params_Data();
  ~Bootstrap_Init_Params_Data() = delete;
};
static_assert(sizeof(Bootstrap_Init_Params_Data) == 24,
              "Bad sizeof(Bootstrap_Init_Params_Data)");

// static
Bootstrap_Init_Params_Data* Bootstrap_Init_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(Bootstrap_Init_Params_Data))) Bootstrap_Init_Params_Data();
}

// static
bool Bootstrap_Init_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Bootstrap_Init_Params_Data* object = static_cast<const Bootstrap_Init_Params_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->to_client_channel,
          "invalid to_client_channel field in Bootstrap_Init_Params", validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->to_client_channel,
                                                 validation_context)) {
    return false;
  }

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->to_server_channel,
          "invalid to_server_channel field in Bootstrap_Init_Params", validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->to_server_channel,
                                                 validation_context)) {
    return false;
  }

  return true;
}

void Bootstrap_Init_Params_Data::EncodePointers() {
  CHECK(header_.version == 0);
}

void Bootstrap_Init_Params_Data::DecodePointers() {
  // NOTE: The memory backing |this| may be smaller than |sizeof(*this)|, if the
  // message comes from an older version.
}

Bootstrap_Init_Params_Data::Bootstrap_Init_Params_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}
class Bootstrap_Init_ResponseParams_Data {
 public:
  static Bootstrap_Init_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  void EncodePointers();
  void DecodePointers();



  mojo::internal::StructHeader header_;
  int32_t pid;
  uint8_t padfinal_[4];

 private:
  Bootstrap_Init_ResponseParams_Data();
  ~Bootstrap_Init_ResponseParams_Data() = delete;
};
static_assert(sizeof(Bootstrap_Init_ResponseParams_Data) == 16,
              "Bad sizeof(Bootstrap_Init_ResponseParams_Data)");

// static
Bootstrap_Init_ResponseParams_Data* Bootstrap_Init_ResponseParams_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(Bootstrap_Init_ResponseParams_Data))) Bootstrap_Init_ResponseParams_Data();
}

// static
bool Bootstrap_Init_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Bootstrap_Init_ResponseParams_Data* object = static_cast<const Bootstrap_Init_ResponseParams_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  return true;
}

void Bootstrap_Init_ResponseParams_Data::EncodePointers() {
  CHECK(header_.version == 0);
}

void Bootstrap_Init_ResponseParams_Data::DecodePointers() {
  // NOTE: The memory backing |this| may be smaller than |sizeof(*this)|, if the
  // message comes from an older version.
}

Bootstrap_Init_ResponseParams_Data::Bootstrap_Init_ResponseParams_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

#pragma pack(pop)

}  // namespace


// static
SerializedHandle_Data* SerializedHandle_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(SerializedHandle_Data))) SerializedHandle_Data();
}

// static
bool SerializedHandle_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const SerializedHandle_Data* object = static_cast<const SerializedHandle_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->the_handle,
          "invalid the_handle field in SerializedHandle", validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->the_handle,
                                                 validation_context)) {
    return false;
  }


  if (!::IPC::mojom::internal::SerializedHandle_Data::Type_Data
        ::Validate(object->type, validation_context))
    return false;

  return true;
}

void SerializedHandle_Data::EncodePointers() {
  CHECK(header_.version == 0);
}

void SerializedHandle_Data::DecodePointers() {
  // NOTE: The memory backing |this| may be smaller than |sizeof(*this)|, if the
  // message comes from an older version.
}

SerializedHandle_Data::SerializedHandle_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}


}  // namespace internal

namespace {

class Channel_Receive_ParamsDataView {
 public:
  Channel_Receive_ParamsDataView(
      internal::Channel_Receive_Params_Data* data,
      mojo::internal::SerializationContext* context);
  template <typename UserType>
  bool ReadData(UserType* value) {
    auto pointer = data_->data.ptr;
    return mojo::internal::Deserialize<mojo::Array<uint8_t>>(
        pointer, value, context_);
  }
  template <typename UserType>
  bool ReadHandles(UserType* value) {
    auto pointer = data_->handles.ptr;
    return mojo::internal::Deserialize<mojo::Array<::IPC::mojom::SerializedHandlePtr>>(
        pointer, value, context_);
  }
 private:
  internal::Channel_Receive_Params_Data* data_;
  mojo::internal::SerializationContext* context_;
};

Channel_Receive_ParamsDataView::Channel_Receive_ParamsDataView(
    internal::Channel_Receive_Params_Data*  data,
    mojo::internal::SerializationContext* context)
    : data_(data), context_(context) {
  DCHECK(data_);
}


class Bootstrap_Init_ParamsDataView {
 public:
  Bootstrap_Init_ParamsDataView(
      internal::Bootstrap_Init_Params_Data* data,
      mojo::internal::SerializationContext* context);
  ChannelAssociatedRequest TakeToClientChannel();
  ChannelAssociatedPtrInfo TakeToServerChannel();
  int32_t pid() const;
 private:
  internal::Bootstrap_Init_Params_Data* data_;
  mojo::internal::SerializationContext* context_;
};

Bootstrap_Init_ParamsDataView::Bootstrap_Init_ParamsDataView(
    internal::Bootstrap_Init_Params_Data*  data,
    mojo::internal::SerializationContext* context)
    : data_(data), context_(context) {
  DCHECK(data_);
}
ChannelAssociatedRequest Bootstrap_Init_ParamsDataView::TakeToClientChannel() {
  ChannelAssociatedRequest result;
  bool ret = mojo::internal::Deserialize<::IPC::mojom::ChannelAssociatedRequest>(
      &data_->to_client_channel, &result, context_);
  DCHECK(ret);
  return result;
}
ChannelAssociatedPtrInfo Bootstrap_Init_ParamsDataView::TakeToServerChannel() {
  ChannelAssociatedPtrInfo result;
  bool ret = mojo::internal::Deserialize<::IPC::mojom::ChannelAssociatedPtrInfo>(
      &data_->to_server_channel, &result, context_);
  DCHECK(ret);
  return result;
}
int32_t Bootstrap_Init_ParamsDataView::pid() const {
  return data_->pid;
}

class Bootstrap_Init_ResponseParamsDataView {
 public:
  Bootstrap_Init_ResponseParamsDataView(
      internal::Bootstrap_Init_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context);
  int32_t pid() const;
 private:
  internal::Bootstrap_Init_ResponseParams_Data* data_;
  mojo::internal::SerializationContext* context_;
};

Bootstrap_Init_ResponseParamsDataView::Bootstrap_Init_ResponseParamsDataView(
    internal::Bootstrap_Init_ResponseParams_Data*  data,
    mojo::internal::SerializationContext* context)
    : data_(data), context_(context) {
  DCHECK(data_);
}
int32_t Bootstrap_Init_ResponseParamsDataView::pid() const {
  return data_->pid;
}


}  // namespace// static
SerializedHandlePtr SerializedHandle::New() {
  SerializedHandlePtr rv;
  mojo::internal::StructHelper<SerializedHandle>::Initialize(&rv);
  return rv;
}

SerializedHandle::SerializedHandle()
    : the_handle(),
      type() {
}

SerializedHandle::~SerializedHandle() {
}SerializedHandleDataView::SerializedHandleDataView(
    internal::SerializedHandle_Data*  data,
    mojo::internal::SerializationContext* context)
    : data_(data), context_(context) {
  DCHECK(data_);
}
mojo::ScopedHandle SerializedHandleDataView::TakeTheHandle() {
  mojo::ScopedHandle result;
  bool ret = mojo::internal::Deserialize<mojo::ScopedHandle>(
      &data_->the_handle, &result, context_);
  DCHECK(ret);
  return result;
}
::IPC::mojom::SerializedHandle::Type SerializedHandleDataView::type() const {
  return static_cast<::IPC::mojom::SerializedHandle::Type>(data_->type);
}

const char Channel::Name_[] = "IPC::mojom::Channel";
const uint32_t Channel::Version_;

ChannelProxy::ChannelProxy(mojo::MessageReceiverWithResponder* receiver)
    : ControlMessageProxy(receiver) {
}

void ChannelProxy::Receive(
    mojo::Array<uint8_t> in_data, mojo::Array<SerializedHandlePtr> in_handles) {
  size_t size = sizeof(::IPC::mojom::internal::Channel_Receive_Params_Data);
  size += mojo::internal::PrepareToSerialize<mojo::Array<uint8_t>>(
      in_data, &serialization_context_);
  size += mojo::internal::PrepareToSerialize<mojo::Array<::IPC::mojom::SerializedHandlePtr>>(
      in_handles, &serialization_context_);
  mojo::internal::MessageBuilder builder(internal::kChannel_Receive_Name, size);

  auto params =
      ::IPC::mojom::internal::Channel_Receive_Params_Data::New(builder.buffer());
  const mojo::internal::ContainerValidateParams data_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::Array<uint8_t>>(
      in_data, builder.buffer(), &params->data.ptr,
      &data_validate_params, &serialization_context_);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !params->data.ptr,
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null data in Channel.Receive request");
  const mojo::internal::ContainerValidateParams handles_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::Array<::IPC::mojom::SerializedHandlePtr>>(
      in_handles, builder.buffer(), &params->handles.ptr,
      &handles_validate_params, &serialization_context_);
  (&serialization_context_)->handles.Swap(
      builder.message()->mutable_handles());
  params->EncodePointers();
  bool ok = receiver_->Accept(builder.message());
  // This return value may be ignored as !ok implies the Connector has
  // encountered an error, which will be visible through other means.
  ALLOW_UNUSED_LOCAL(ok);
}

ChannelStub::ChannelStub()
    : sink_(nullptr),
      control_message_handler_(Channel::Version_) {
}

ChannelStub::~ChannelStub() {}

bool ChannelStub::Accept(mojo::Message* message) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return control_message_handler_.Accept(message);
  switch (message->header()->name) {
    case internal::kChannel_Receive_Name: {
      internal::Channel_Receive_Params_Data* params =
          reinterpret_cast<internal::Channel_Receive_Params_Data*>(
              message->mutable_payload());

      
      (params)->DecodePointers();
      (&serialization_context_)->handles.Swap((message)->mutable_handles());
      bool success = true;
      mojo::Array<uint8_t> p_data{};
      mojo::Array<SerializedHandlePtr> p_handles{};
      Channel_Receive_ParamsDataView input_data_view(params,
                                              &serialization_context_);
      
      if (!input_data_view.ReadData(&p_data))
        success = false;
      if (!input_data_view.ReadHandles(&p_handles))
        success = false;
      if (!success) {
        mojo::internal::ValidationContext validation_context(
            message->data(), message->data_num_bytes(),
            message->handles()->size(), message,
            "{{class_name}}::{{method.name}} deserializer");
        ReportValidationError(
            &validation_context,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED);
        return false;
      }
      // A null |sink_| means no implementation was bound.
      assert(sink_);
      TRACE_EVENT0("mojom", "Channel::Receive");
      sink_->Receive(
std::move(p_data), 
std::move(p_handles));
      return true;
    }
  }
  return false;
}

bool ChannelStub::AcceptWithResponder(
    mojo::Message* message, mojo::MessageReceiverWithStatus* responder) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return control_message_handler_.AcceptWithResponder(message, responder);
  switch (message->header()->name) {
    case internal::kChannel_Receive_Name: {
      break;
    }
  }
  return false;
}

ChannelRequestValidator::ChannelRequestValidator(
    mojo::MessageReceiver* sink) : MessageFilter(sink) {
}

bool ChannelRequestValidator::Accept(mojo::Message* message) {
  assert(sink_);

  mojo::internal::ValidationContext validation_context(
    message->data(), message->data_num_bytes(), message->handles()->size(),
    message, "Channel RequestValidator");

  if (mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    if (!mojo::internal::ValidateControlRequest(message, &validation_context))
      return false;
    return sink_->Accept(message);
  }

  switch (message->header()->name) {
    case internal::kChannel_Receive_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::Channel_Receive_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return sink_->Accept(message);
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

const char Bootstrap::Name_[] = "IPC::mojom::Bootstrap";
const uint32_t Bootstrap::Version_;

class Bootstrap_Init_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  Bootstrap_Init_ForwardToCallback(
      const Bootstrap::InitCallback& callback,
      scoped_refptr<mojo::AssociatedGroupController> group_controller)
      : callback_(callback),
        serialization_context_(std::move(group_controller)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  Bootstrap::InitCallback callback_;
  mojo::internal::SerializationContext serialization_context_;
  DISALLOW_COPY_AND_ASSIGN(Bootstrap_Init_ForwardToCallback);
};
bool Bootstrap_Init_ForwardToCallback::Accept(
    mojo::Message* message) {
  internal::Bootstrap_Init_ResponseParams_Data* params =
      reinterpret_cast<internal::Bootstrap_Init_ResponseParams_Data*>(
          message->mutable_payload());

  
  (params)->DecodePointers();
  (&serialization_context_)->handles.Swap((message)->mutable_handles());
  bool success = true;
  int32_t p_pid{};
  Bootstrap_Init_ResponseParamsDataView input_data_view(params,
                                          &serialization_context_);
  
  p_pid = input_data_view.pid();
  if (!success) {
    mojo::internal::ValidationContext validation_context(
        message->data(), message->data_num_bytes(),
        message->handles()->size(), message,
        "{{class_name}}_{{method.name}} response deserializer");
    ReportValidationError(
        &validation_context,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED);
    return false;
  }
  if (!callback_.is_null())
    callback_.Run(
std::move(p_pid));
  return true;
}

BootstrapProxy::BootstrapProxy(mojo::MessageReceiverWithResponder* receiver)
    : ControlMessageProxy(receiver) {
}

void BootstrapProxy::Init(
    ChannelAssociatedRequest in_to_client_channel, ChannelAssociatedPtrInfo in_to_server_channel, int32_t in_pid, const InitCallback& callback) {
  size_t size = sizeof(::IPC::mojom::internal::Bootstrap_Init_Params_Data);
  mojo::internal::RequestMessageBuilder builder(internal::kBootstrap_Init_Name, size);

  auto params =
      ::IPC::mojom::internal::Bootstrap_Init_Params_Data::New(builder.buffer());
  mojo::internal::Serialize<::IPC::mojom::ChannelAssociatedRequest>(
      in_to_client_channel, &params->to_client_channel, &serialization_context_);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->to_client_channel),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_INTERFACE_ID,
      "invalid to_client_channel in Bootstrap.Init request");
  mojo::internal::Serialize<::IPC::mojom::ChannelAssociatedPtrInfo>(
      in_to_server_channel, &params->to_server_channel, &serialization_context_);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->to_server_channel),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_INTERFACE_ID,
      "invalid to_server_channel in Bootstrap.Init request");
  params->pid = in_pid;
  (&serialization_context_)->handles.Swap(
      builder.message()->mutable_handles());
  params->EncodePointers();
  mojo::MessageReceiver* responder =
      new Bootstrap_Init_ForwardToCallback(
          callback, serialization_context_.group_controller);
  if (!receiver_->AcceptWithResponder(builder.message(), responder))
    delete responder;
}
class Bootstrap_Init_ProxyToResponder
    : public base::RefCountedThreadSafe<
          Bootstrap_Init_ProxyToResponder> {
 public:
  static Bootstrap::InitCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      mojo::MessageReceiverWithStatus* responder,
      scoped_refptr<mojo::AssociatedGroupController>
          group_controller) {
    scoped_refptr<Bootstrap_Init_ProxyToResponder> proxy
        = new Bootstrap_Init_ProxyToResponder(
            request_id, is_sync, responder, group_controller);
    return base::Bind(&Bootstrap_Init_ProxyToResponder::Run,
                      proxy);
  }

 private:
  friend class base::RefCountedThreadSafe<
      Bootstrap_Init_ProxyToResponder>;

  Bootstrap_Init_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      mojo::MessageReceiverWithStatus* responder,
      scoped_refptr<mojo::AssociatedGroupController> group_controller)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(responder),
        serialization_context_(std::move(group_controller)) {
  }

  ~Bootstrap_Init_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // Is the Mojo application destroying the callback without running it
      // and without first closing the pipe?
      responder_->DCheckInvalid("The callback passed to "
          "Bootstrap::Init() was never run.");
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    delete responder_;
  }

  void Run(
      int32_t in_pid);

  uint64_t request_id_;
  bool is_sync_;
  mojo::MessageReceiverWithStatus* responder_;
  // TODO(yzshen): maybe I should use a ref to the original one?
  mojo::internal::SerializationContext serialization_context_;

  DISALLOW_COPY_AND_ASSIGN(Bootstrap_Init_ProxyToResponder);
};

void Bootstrap_Init_ProxyToResponder::Run(
    int32_t in_pid) {
  size_t size = sizeof(::IPC::mojom::internal::Bootstrap_Init_ResponseParams_Data);
  mojo::internal::ResponseMessageBuilder builder(
      internal::kBootstrap_Init_Name, size, request_id_,
      is_sync_ ? mojo::Message::kFlagIsSync : 0);
  auto params =
      ::IPC::mojom::internal::Bootstrap_Init_ResponseParams_Data::New(builder.buffer());
  params->pid = in_pid;
  (&serialization_context_)->handles.Swap(
      builder.message()->mutable_handles());
  params->EncodePointers();
  bool ok = responder_->Accept(builder.message());
  ALLOW_UNUSED_LOCAL(ok);
  // TODO(darin): !ok returned here indicates a malformed message, and that may
  // be good reason to close the connection. However, we don't have a way to do
  // that from here. We should add a way.
  delete responder_;
  responder_ = nullptr;
}

BootstrapStub::BootstrapStub()
    : sink_(nullptr),
      control_message_handler_(Bootstrap::Version_) {
}

BootstrapStub::~BootstrapStub() {}

bool BootstrapStub::Accept(mojo::Message* message) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return control_message_handler_.Accept(message);
  switch (message->header()->name) {
    case internal::kBootstrap_Init_Name: {
      break;
    }
  }
  return false;
}

bool BootstrapStub::AcceptWithResponder(
    mojo::Message* message, mojo::MessageReceiverWithStatus* responder) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return control_message_handler_.AcceptWithResponder(message, responder);
  switch (message->header()->name) {
    case internal::kBootstrap_Init_Name: {
      internal::Bootstrap_Init_Params_Data* params =
          reinterpret_cast<internal::Bootstrap_Init_Params_Data*>(
              message->mutable_payload());

      
      (params)->DecodePointers();
      (&serialization_context_)->handles.Swap((message)->mutable_handles());
      bool success = true;
      ChannelAssociatedRequest p_to_client_channel{};
      ChannelAssociatedPtrInfo p_to_server_channel{};
      int32_t p_pid{};
      Bootstrap_Init_ParamsDataView input_data_view(params,
                                              &serialization_context_);
      
      p_to_client_channel = input_data_view.TakeToClientChannel();
      p_to_server_channel = input_data_view.TakeToServerChannel();
      p_pid = input_data_view.pid();
      if (!success) {
        mojo::internal::ValidationContext validation_context(
            message->data(), message->data_num_bytes(),
            message->handles()->size(), message,
            "{{class_name}}::{{method.name}} deserializer");
        ReportValidationError(
            &validation_context,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED);
        return false;
      }
      Bootstrap::InitCallback callback =
          Bootstrap_Init_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              responder,
              serialization_context_.group_controller);
      // A null |sink_| means no implementation was bound.
      assert(sink_);
      TRACE_EVENT0("mojom", "Bootstrap::Init");
      sink_->Init(
std::move(p_to_client_channel), 
std::move(p_to_server_channel), 
std::move(p_pid), callback);
      return true;
    }
  }
  return false;
}

BootstrapRequestValidator::BootstrapRequestValidator(
    mojo::MessageReceiver* sink) : MessageFilter(sink) {
}

bool BootstrapRequestValidator::Accept(mojo::Message* message) {
  assert(sink_);

  mojo::internal::ValidationContext validation_context(
    message->data(), message->data_num_bytes(), message->handles()->size(),
    message, "Bootstrap RequestValidator");

  if (mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    if (!mojo::internal::ValidateControlRequest(message, &validation_context))
      return false;
    return sink_->Accept(message);
  }

  switch (message->header()->name) {
    case internal::kBootstrap_Init_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::Bootstrap_Init_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return sink_->Accept(message);
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

BootstrapResponseValidator::BootstrapResponseValidator(
    mojo::MessageReceiver* sink) : MessageFilter(sink) {
}

bool BootstrapResponseValidator::Accept(mojo::Message* message) {
  assert(sink_);

  mojo::internal::ValidationContext validation_context(
    message->data(), message->data_num_bytes(), message->handles()->size(),
    message, "Bootstrap ResponseValidator");

  if (mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    if (!mojo::internal::ValidateControlResponse(message, &validation_context))
      return false;
    return sink_->Accept(message);
  }

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kBootstrap_Init_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::Bootstrap_Init_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return sink_->Accept(message);
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
}  // namespace mojom
}  // namespace IPC

namespace mojo {


// static
bool StructTraits<::IPC::mojom::SerializedHandle, ::IPC::mojom::SerializedHandlePtr>::Read(
    ::IPC::mojom::SerializedHandleDataView input,
    ::IPC::mojom::SerializedHandlePtr* output) {
  bool success = true;
  ::IPC::mojom::SerializedHandlePtr result(::IPC::mojom::SerializedHandle::New());
  
      result->the_handle = input.TakeTheHandle();
      if (!input.ReadType(&result->type))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo


#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif