// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/trace_event/trace_event.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/message_builder.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
namespace mojo {

namespace internal {
namespace {

#pragma pack(push, 1)

#pragma pack(pop)

}  // namespace


// static
RunMessageParams_Data* RunMessageParams_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(RunMessageParams_Data))) RunMessageParams_Data();
}

// static
bool RunMessageParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const RunMessageParams_Data* object = static_cast<const RunMessageParams_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->query_version, "null query_version field in RunMessageParams",
          validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->query_version, validation_context))
    return false;

  return true;
}

void RunMessageParams_Data::EncodePointers() {
  CHECK(header_.version == 0);
  mojo::internal::Encode(&this->query_version);
}

void RunMessageParams_Data::DecodePointers() {
  // NOTE: The memory backing |this| may be smaller than |sizeof(*this)|, if the
  // message comes from an older version.
  mojo::internal::Decode(&this->query_version);
}

RunMessageParams_Data::RunMessageParams_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

// static
RunResponseMessageParams_Data* RunResponseMessageParams_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(RunResponseMessageParams_Data))) RunResponseMessageParams_Data();
}

// static
bool RunResponseMessageParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const RunResponseMessageParams_Data* object = static_cast<const RunResponseMessageParams_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->query_version_result, "null query_version_result field in RunResponseMessageParams",
          validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->query_version_result, validation_context))
    return false;

  return true;
}

void RunResponseMessageParams_Data::EncodePointers() {
  CHECK(header_.version == 0);
  mojo::internal::Encode(&this->query_version_result);
}

void RunResponseMessageParams_Data::DecodePointers() {
  // NOTE: The memory backing |this| may be smaller than |sizeof(*this)|, if the
  // message comes from an older version.
  mojo::internal::Decode(&this->query_version_result);
}

RunResponseMessageParams_Data::RunResponseMessageParams_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

// static
QueryVersion_Data* QueryVersion_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(QueryVersion_Data))) QueryVersion_Data();
}

// static
bool QueryVersion_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const QueryVersion_Data* object = static_cast<const QueryVersion_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 8 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  return true;
}

void QueryVersion_Data::EncodePointers() {
  CHECK(header_.version == 0);
}

void QueryVersion_Data::DecodePointers() {
  // NOTE: The memory backing |this| may be smaller than |sizeof(*this)|, if the
  // message comes from an older version.
}

QueryVersion_Data::QueryVersion_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

// static
QueryVersionResult_Data* QueryVersionResult_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(QueryVersionResult_Data))) QueryVersionResult_Data();
}

// static
bool QueryVersionResult_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const QueryVersionResult_Data* object = static_cast<const QueryVersionResult_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  return true;
}

void QueryVersionResult_Data::EncodePointers() {
  CHECK(header_.version == 0);
}

void QueryVersionResult_Data::DecodePointers() {
  // NOTE: The memory backing |this| may be smaller than |sizeof(*this)|, if the
  // message comes from an older version.
}

QueryVersionResult_Data::QueryVersionResult_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

// static
RunOrClosePipeMessageParams_Data* RunOrClosePipeMessageParams_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(RunOrClosePipeMessageParams_Data))) RunOrClosePipeMessageParams_Data();
}

// static
bool RunOrClosePipeMessageParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const RunOrClosePipeMessageParams_Data* object = static_cast<const RunOrClosePipeMessageParams_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->require_version, "null require_version field in RunOrClosePipeMessageParams",
          validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->require_version, validation_context))
    return false;

  return true;
}

void RunOrClosePipeMessageParams_Data::EncodePointers() {
  CHECK(header_.version == 0);
  mojo::internal::Encode(&this->require_version);
}

void RunOrClosePipeMessageParams_Data::DecodePointers() {
  // NOTE: The memory backing |this| may be smaller than |sizeof(*this)|, if the
  // message comes from an older version.
  mojo::internal::Decode(&this->require_version);
}

RunOrClosePipeMessageParams_Data::RunOrClosePipeMessageParams_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

// static
RequireVersion_Data* RequireVersion_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(RequireVersion_Data))) RequireVersion_Data();
}

// static
bool RequireVersion_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const RequireVersion_Data* object = static_cast<const RequireVersion_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  return true;
}

void RequireVersion_Data::EncodePointers() {
  CHECK(header_.version == 0);
}

void RequireVersion_Data::DecodePointers() {
  // NOTE: The memory backing |this| may be smaller than |sizeof(*this)|, if the
  // message comes from an older version.
}

RequireVersion_Data::RequireVersion_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}


}  // namespace internal

namespace {

}  // namespace// static
RunMessageParamsPtr RunMessageParams::New() {
  RunMessageParamsPtr rv;
  mojo::internal::StructHelper<RunMessageParams>::Initialize(&rv);
  return rv;
}

RunMessageParams::RunMessageParams()
    : reserved0(),
      reserved1(),
      query_version() {
}

RunMessageParams::~RunMessageParams() {
}RunMessageParamsDataView::RunMessageParamsDataView(
    internal::RunMessageParams_Data*  data,
    mojo::internal::SerializationContext* context)
    : data_(data), context_(context) {
  DCHECK(data_);
}
uint32_t RunMessageParamsDataView::reserved0() const {
  return data_->reserved0;
}
uint32_t RunMessageParamsDataView::reserved1() const {
  return data_->reserved1;
}
// static
RunResponseMessageParamsPtr RunResponseMessageParams::New() {
  RunResponseMessageParamsPtr rv;
  mojo::internal::StructHelper<RunResponseMessageParams>::Initialize(&rv);
  return rv;
}

RunResponseMessageParams::RunResponseMessageParams()
    : reserved0(),
      reserved1(),
      query_version_result() {
}

RunResponseMessageParams::~RunResponseMessageParams() {
}RunResponseMessageParamsDataView::RunResponseMessageParamsDataView(
    internal::RunResponseMessageParams_Data*  data,
    mojo::internal::SerializationContext* context)
    : data_(data), context_(context) {
  DCHECK(data_);
}
uint32_t RunResponseMessageParamsDataView::reserved0() const {
  return data_->reserved0;
}
uint32_t RunResponseMessageParamsDataView::reserved1() const {
  return data_->reserved1;
}
// static
QueryVersionPtr QueryVersion::New() {
  QueryVersionPtr rv;
  mojo::internal::StructHelper<QueryVersion>::Initialize(&rv);
  return rv;
}

QueryVersion::QueryVersion() {
}

QueryVersion::~QueryVersion() {
}QueryVersionDataView::QueryVersionDataView(
    internal::QueryVersion_Data*  data,
    mojo::internal::SerializationContext* context)
    : data_(data), context_(context) {
  DCHECK(data_);
}
// static
QueryVersionResultPtr QueryVersionResult::New() {
  QueryVersionResultPtr rv;
  mojo::internal::StructHelper<QueryVersionResult>::Initialize(&rv);
  return rv;
}

QueryVersionResult::QueryVersionResult()
    : version() {
}

QueryVersionResult::~QueryVersionResult() {
}QueryVersionResultDataView::QueryVersionResultDataView(
    internal::QueryVersionResult_Data*  data,
    mojo::internal::SerializationContext* context)
    : data_(data), context_(context) {
  DCHECK(data_);
}
uint32_t QueryVersionResultDataView::version() const {
  return data_->version;
}
// static
RunOrClosePipeMessageParamsPtr RunOrClosePipeMessageParams::New() {
  RunOrClosePipeMessageParamsPtr rv;
  mojo::internal::StructHelper<RunOrClosePipeMessageParams>::Initialize(&rv);
  return rv;
}

RunOrClosePipeMessageParams::RunOrClosePipeMessageParams()
    : reserved0(),
      reserved1(),
      require_version() {
}

RunOrClosePipeMessageParams::~RunOrClosePipeMessageParams() {
}RunOrClosePipeMessageParamsDataView::RunOrClosePipeMessageParamsDataView(
    internal::RunOrClosePipeMessageParams_Data*  data,
    mojo::internal::SerializationContext* context)
    : data_(data), context_(context) {
  DCHECK(data_);
}
uint32_t RunOrClosePipeMessageParamsDataView::reserved0() const {
  return data_->reserved0;
}
uint32_t RunOrClosePipeMessageParamsDataView::reserved1() const {
  return data_->reserved1;
}
// static
RequireVersionPtr RequireVersion::New() {
  RequireVersionPtr rv;
  mojo::internal::StructHelper<RequireVersion>::Initialize(&rv);
  return rv;
}

RequireVersion::RequireVersion()
    : version() {
}

RequireVersion::~RequireVersion() {
}RequireVersionDataView::RequireVersionDataView(
    internal::RequireVersion_Data*  data,
    mojo::internal::SerializationContext* context)
    : data_(data), context_(context) {
  DCHECK(data_);
}
uint32_t RequireVersionDataView::version() const {
  return data_->version;
}

}  // namespace mojo

namespace mojo {


// static
bool StructTraits<::mojo::RunMessageParams, ::mojo::RunMessageParamsPtr>::Read(
    ::mojo::RunMessageParamsDataView input,
    ::mojo::RunMessageParamsPtr* output) {
  bool success = true;
  ::mojo::RunMessageParamsPtr result(::mojo::RunMessageParams::New());
  
      result->reserved0 = input.reserved0();
      result->reserved1 = input.reserved1();
      if (!input.ReadQueryVersion(&result->query_version))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::mojo::RunResponseMessageParams, ::mojo::RunResponseMessageParamsPtr>::Read(
    ::mojo::RunResponseMessageParamsDataView input,
    ::mojo::RunResponseMessageParamsPtr* output) {
  bool success = true;
  ::mojo::RunResponseMessageParamsPtr result(::mojo::RunResponseMessageParams::New());
  
      result->reserved0 = input.reserved0();
      result->reserved1 = input.reserved1();
      if (!input.ReadQueryVersionResult(&result->query_version_result))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::mojo::QueryVersion, ::mojo::QueryVersionPtr>::Read(
    ::mojo::QueryVersionDataView input,
    ::mojo::QueryVersionPtr* output) {
  bool success = true;
  ::mojo::QueryVersionPtr result(::mojo::QueryVersion::New());
  
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::mojo::QueryVersionResult, ::mojo::QueryVersionResultPtr>::Read(
    ::mojo::QueryVersionResultDataView input,
    ::mojo::QueryVersionResultPtr* output) {
  bool success = true;
  ::mojo::QueryVersionResultPtr result(::mojo::QueryVersionResult::New());
  
      result->version = input.version();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::mojo::RunOrClosePipeMessageParams, ::mojo::RunOrClosePipeMessageParamsPtr>::Read(
    ::mojo::RunOrClosePipeMessageParamsDataView input,
    ::mojo::RunOrClosePipeMessageParamsPtr* output) {
  bool success = true;
  ::mojo::RunOrClosePipeMessageParamsPtr result(::mojo::RunOrClosePipeMessageParams::New());
  
      result->reserved0 = input.reserved0();
      result->reserved1 = input.reserved1();
      if (!input.ReadRequireVersion(&result->require_version))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::mojo::RequireVersion, ::mojo::RequireVersionPtr>::Read(
    ::mojo::RequireVersionDataView input,
    ::mojo::RequireVersionPtr* output) {
  bool success = true;
  ::mojo::RequireVersionPtr result(::mojo::RequireVersion::New());
  
      result->version = input.version();
  *output = std::move(result);
  return success;
}

}  // namespace mojo


#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif