// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "mojo/public/interfaces/bindings/pipe_control_messages.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/trace_event/trace_event.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/message_builder.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
namespace mojo {
namespace pipe_control {

namespace internal {
namespace {

#pragma pack(push, 1)

#pragma pack(pop)

}  // namespace


// static
RunOrClosePipeMessageParams_Data* RunOrClosePipeMessageParams_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(RunOrClosePipeMessageParams_Data))) RunOrClosePipeMessageParams_Data();
}

// static
bool RunOrClosePipeMessageParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const RunOrClosePipeMessageParams_Data* object = static_cast<const RunOrClosePipeMessageParams_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidateInlinedUnionNonNullable(
          object->input, "null input field in RunOrClosePipeMessageParams",
          validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateInlinedUnion(object->input, validation_context))
    return false;

  return true;
}

void RunOrClosePipeMessageParams_Data::EncodePointers() {
  CHECK(header_.version == 0);
  this->input.EncodePointers();
}

void RunOrClosePipeMessageParams_Data::DecodePointers() {
  // NOTE: The memory backing |this| may be smaller than |sizeof(*this)|, if the
  // message comes from an older version.
  this->input.DecodePointers();
}

RunOrClosePipeMessageParams_Data::RunOrClosePipeMessageParams_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

// static
PeerAssociatedEndpointClosedEvent_Data* PeerAssociatedEndpointClosedEvent_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(PeerAssociatedEndpointClosedEvent_Data))) PeerAssociatedEndpointClosedEvent_Data();
}

// static
bool PeerAssociatedEndpointClosedEvent_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PeerAssociatedEndpointClosedEvent_Data* object = static_cast<const PeerAssociatedEndpointClosedEvent_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  return true;
}

void PeerAssociatedEndpointClosedEvent_Data::EncodePointers() {
  CHECK(header_.version == 0);
}

void PeerAssociatedEndpointClosedEvent_Data::DecodePointers() {
  // NOTE: The memory backing |this| may be smaller than |sizeof(*this)|, if the
  // message comes from an older version.
}

PeerAssociatedEndpointClosedEvent_Data::PeerAssociatedEndpointClosedEvent_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

// static
AssociatedEndpointClosedBeforeSentEvent_Data* AssociatedEndpointClosedBeforeSentEvent_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(AssociatedEndpointClosedBeforeSentEvent_Data))) AssociatedEndpointClosedBeforeSentEvent_Data();
}

// static
bool AssociatedEndpointClosedBeforeSentEvent_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, validation_context))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const AssociatedEndpointClosedBeforeSentEvent_Data* object = static_cast<const AssociatedEndpointClosedBeforeSentEvent_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[arraysize(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = arraysize(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            validation_context,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[arraysize(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        validation_context,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  return true;
}

void AssociatedEndpointClosedBeforeSentEvent_Data::EncodePointers() {
  CHECK(header_.version == 0);
}

void AssociatedEndpointClosedBeforeSentEvent_Data::DecodePointers() {
  // NOTE: The memory backing |this| may be smaller than |sizeof(*this)|, if the
  // message comes from an older version.
}

AssociatedEndpointClosedBeforeSentEvent_Data::AssociatedEndpointClosedBeforeSentEvent_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}
// static
RunOrClosePipeInput_Data* RunOrClosePipeInput_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(RunOrClosePipeInput_Data))) RunOrClosePipeInput_Data();
}

// static
bool RunOrClosePipeInput_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context,
    bool inlined) {
  if (!data)
    return true;

  if (!ValidateUnionHeaderAndClaimMemory(data, inlined, validation_context))
    return false;

  const RunOrClosePipeInput_Data* object = static_cast<const RunOrClosePipeInput_Data*>(data);
  ALLOW_UNUSED_LOCAL(object);

  switch (object->tag) {

    case RunOrClosePipeInput_Tag::PEER_ASSOCIATED_ENDPOINT_CLOSED_EVENT: {

      if (!mojo::internal::ValidatePointerNonNullable(
              object->data.f_peer_associated_endpoint_closed_event, "null peer_associated_endpoint_closed_event field in RunOrClosePipeInput",
              validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateStruct(object->data.f_peer_associated_endpoint_closed_event, validation_context))
        return false;
      return true;
    }
    case RunOrClosePipeInput_Tag::ASSOCIATED_ENDPOINT_CLOSED_BEFORE_SENT_EVENT: {

      if (!mojo::internal::ValidatePointerNonNullable(
              object->data.f_associated_endpoint_closed_before_sent_event, "null associated_endpoint_closed_before_sent_event field in RunOrClosePipeInput",
              validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateStruct(object->data.f_associated_endpoint_closed_before_sent_event, validation_context))
        return false;
      return true;
    }
    default: {
      ReportValidationError(
          validation_context,
          mojo::internal::VALIDATION_ERROR_UNKNOWN_UNION_TAG,
          "unknown tag in RunOrClosePipeInput");
      return false;
    }
  }
}

void RunOrClosePipeInput_Data::set_null() {
  size = 0U;
  tag = static_cast<RunOrClosePipeInput_Tag>(0);
  data.unknown = 0U;
}

RunOrClosePipeInput_Data::RunOrClosePipeInput_Data() {
}

void RunOrClosePipeInput_Data::EncodePointers() {
  switch (tag) {
    case RunOrClosePipeInput_Tag::PEER_ASSOCIATED_ENDPOINT_CLOSED_EVENT: {
      mojo::internal::Encode(&data.f_peer_associated_endpoint_closed_event);
      return;
    }
    case RunOrClosePipeInput_Tag::ASSOCIATED_ENDPOINT_CLOSED_BEFORE_SENT_EVENT: {
      mojo::internal::Encode(&data.f_associated_endpoint_closed_before_sent_event);
      return;
    }
  }
}

void RunOrClosePipeInput_Data::DecodePointers() {
  switch (tag) {
    case RunOrClosePipeInput_Tag::PEER_ASSOCIATED_ENDPOINT_CLOSED_EVENT: {
      mojo::internal::Decode(&data.f_peer_associated_endpoint_closed_event);
      return;
    }
    case RunOrClosePipeInput_Tag::ASSOCIATED_ENDPOINT_CLOSED_BEFORE_SENT_EVENT: {
      mojo::internal::Decode(&data.f_associated_endpoint_closed_before_sent_event);
      return;
    }
  }
}

}  // namespace internal

namespace {

}  // namespace// static
RunOrClosePipeMessageParamsPtr RunOrClosePipeMessageParams::New() {
  RunOrClosePipeMessageParamsPtr rv;
  mojo::internal::StructHelper<RunOrClosePipeMessageParams>::Initialize(&rv);
  return rv;
}

RunOrClosePipeMessageParams::RunOrClosePipeMessageParams()
    : input() {
}

RunOrClosePipeMessageParams::~RunOrClosePipeMessageParams() {
}RunOrClosePipeMessageParamsDataView::RunOrClosePipeMessageParamsDataView(
    internal::RunOrClosePipeMessageParams_Data*  data,
    mojo::internal::SerializationContext* context)
    : data_(data), context_(context) {
  DCHECK(data_);
}
bool RunOrClosePipeMessageParamsDataView::ReadInput(
    RunOrClosePipeInputPtr* value) {
    auto pointer = &data_->input;
  return mojo::internal::Deserialize<::mojo::pipe_control::RunOrClosePipeInputPtr>(
      pointer, value, context_);
}
// static
PeerAssociatedEndpointClosedEventPtr PeerAssociatedEndpointClosedEvent::New() {
  PeerAssociatedEndpointClosedEventPtr rv;
  mojo::internal::StructHelper<PeerAssociatedEndpointClosedEvent>::Initialize(&rv);
  return rv;
}

PeerAssociatedEndpointClosedEvent::PeerAssociatedEndpointClosedEvent()
    : id() {
}

PeerAssociatedEndpointClosedEvent::~PeerAssociatedEndpointClosedEvent() {
}PeerAssociatedEndpointClosedEventDataView::PeerAssociatedEndpointClosedEventDataView(
    internal::PeerAssociatedEndpointClosedEvent_Data*  data,
    mojo::internal::SerializationContext* context)
    : data_(data), context_(context) {
  DCHECK(data_);
}
uint32_t PeerAssociatedEndpointClosedEventDataView::id() const {
  return data_->id;
}
// static
AssociatedEndpointClosedBeforeSentEventPtr AssociatedEndpointClosedBeforeSentEvent::New() {
  AssociatedEndpointClosedBeforeSentEventPtr rv;
  mojo::internal::StructHelper<AssociatedEndpointClosedBeforeSentEvent>::Initialize(&rv);
  return rv;
}

AssociatedEndpointClosedBeforeSentEvent::AssociatedEndpointClosedBeforeSentEvent()
    : id() {
}

AssociatedEndpointClosedBeforeSentEvent::~AssociatedEndpointClosedBeforeSentEvent() {
}AssociatedEndpointClosedBeforeSentEventDataView::AssociatedEndpointClosedBeforeSentEventDataView(
    internal::AssociatedEndpointClosedBeforeSentEvent_Data*  data,
    mojo::internal::SerializationContext* context)
    : data_(data), context_(context) {
  DCHECK(data_);
}
uint32_t AssociatedEndpointClosedBeforeSentEventDataView::id() const {
  return data_->id;
}
// static
RunOrClosePipeInputPtr RunOrClosePipeInput::New() {
  RunOrClosePipeInputPtr rv;
  mojo::internal::StructHelper<RunOrClosePipeInput>::Initialize(&rv);
  return rv;
}

RunOrClosePipeInput::RunOrClosePipeInput() {
  // TODO(azani): Implement default values here when/if we support them.
  // TODO(azani): Set to UNKNOWN when unknown is implemented.
  SetActive(static_cast<Tag>(0));
}

RunOrClosePipeInput::~RunOrClosePipeInput() {
  DestroyActive();
}


bool RunOrClosePipeInput::is_peer_associated_endpoint_closed_event() const {
  return tag_ == Tag::PEER_ASSOCIATED_ENDPOINT_CLOSED_EVENT;
}

PeerAssociatedEndpointClosedEventPtr& RunOrClosePipeInput::get_peer_associated_endpoint_closed_event() const {
  DCHECK(tag_ == Tag::PEER_ASSOCIATED_ENDPOINT_CLOSED_EVENT);

  return *(data_.peer_associated_endpoint_closed_event);
}

void RunOrClosePipeInput::set_peer_associated_endpoint_closed_event(PeerAssociatedEndpointClosedEventPtr peer_associated_endpoint_closed_event) {
  SwitchActive(Tag::PEER_ASSOCIATED_ENDPOINT_CLOSED_EVENT);

  *(data_.peer_associated_endpoint_closed_event) = std::move(peer_associated_endpoint_closed_event);
}
bool RunOrClosePipeInput::is_associated_endpoint_closed_before_sent_event() const {
  return tag_ == Tag::ASSOCIATED_ENDPOINT_CLOSED_BEFORE_SENT_EVENT;
}

AssociatedEndpointClosedBeforeSentEventPtr& RunOrClosePipeInput::get_associated_endpoint_closed_before_sent_event() const {
  DCHECK(tag_ == Tag::ASSOCIATED_ENDPOINT_CLOSED_BEFORE_SENT_EVENT);

  return *(data_.associated_endpoint_closed_before_sent_event);
}

void RunOrClosePipeInput::set_associated_endpoint_closed_before_sent_event(AssociatedEndpointClosedBeforeSentEventPtr associated_endpoint_closed_before_sent_event) {
  SwitchActive(Tag::ASSOCIATED_ENDPOINT_CLOSED_BEFORE_SENT_EVENT);

  *(data_.associated_endpoint_closed_before_sent_event) = std::move(associated_endpoint_closed_before_sent_event);
}

void RunOrClosePipeInput::SwitchActive(Tag new_active) {
  if (new_active == tag_) {
    return;
  }

  DestroyActive();
  SetActive(new_active);
}

void RunOrClosePipeInput::SetActive(Tag new_active) {
  switch (new_active) {

    case Tag::PEER_ASSOCIATED_ENDPOINT_CLOSED_EVENT:

      data_.peer_associated_endpoint_closed_event = new PeerAssociatedEndpointClosedEventPtr();
      break;
    case Tag::ASSOCIATED_ENDPOINT_CLOSED_BEFORE_SENT_EVENT:

      data_.associated_endpoint_closed_before_sent_event = new AssociatedEndpointClosedBeforeSentEventPtr();
      break;
  }

  tag_ = new_active;
}

void RunOrClosePipeInput::DestroyActive() {
  switch (tag_) {

    case Tag::PEER_ASSOCIATED_ENDPOINT_CLOSED_EVENT:

      delete data_.peer_associated_endpoint_closed_event;
      break;
    case Tag::ASSOCIATED_ENDPOINT_CLOSED_BEFORE_SENT_EVENT:

      delete data_.associated_endpoint_closed_before_sent_event;
      break;
  }
}
}  // namespace pipe_control
}  // namespace mojo

namespace mojo {


// static
bool StructTraits<::mojo::pipe_control::RunOrClosePipeMessageParams, ::mojo::pipe_control::RunOrClosePipeMessageParamsPtr>::Read(
    ::mojo::pipe_control::RunOrClosePipeMessageParamsDataView input,
    ::mojo::pipe_control::RunOrClosePipeMessageParamsPtr* output) {
  bool success = true;
  ::mojo::pipe_control::RunOrClosePipeMessageParamsPtr result(::mojo::pipe_control::RunOrClosePipeMessageParams::New());
  
      if (!input.ReadInput(&result->input))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::mojo::pipe_control::PeerAssociatedEndpointClosedEvent, ::mojo::pipe_control::PeerAssociatedEndpointClosedEventPtr>::Read(
    ::mojo::pipe_control::PeerAssociatedEndpointClosedEventDataView input,
    ::mojo::pipe_control::PeerAssociatedEndpointClosedEventPtr* output) {
  bool success = true;
  ::mojo::pipe_control::PeerAssociatedEndpointClosedEventPtr result(::mojo::pipe_control::PeerAssociatedEndpointClosedEvent::New());
  
      result->id = input.id();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::mojo::pipe_control::AssociatedEndpointClosedBeforeSentEvent, ::mojo::pipe_control::AssociatedEndpointClosedBeforeSentEventPtr>::Read(
    ::mojo::pipe_control::AssociatedEndpointClosedBeforeSentEventDataView input,
    ::mojo::pipe_control::AssociatedEndpointClosedBeforeSentEventPtr* output) {
  bool success = true;
  ::mojo::pipe_control::AssociatedEndpointClosedBeforeSentEventPtr result(::mojo::pipe_control::AssociatedEndpointClosedBeforeSentEvent::New());
  
      result->id = input.id();
  *output = std::move(result);
  return success;
}

namespace internal {

// static
size_t UnionSerializerImpl<::mojo::pipe_control::RunOrClosePipeInputPtr>::PrepareToSerialize(
    ::mojo::pipe_control::RunOrClosePipeInputPtr& input,
    bool inlined,
    SerializationContext* context) {
  size_t size = inlined ? 0 : sizeof(::mojo::pipe_control::internal::RunOrClosePipeInput_Data);

  if (!input)
    return size;

  UnionAccessor<::mojo::pipe_control::RunOrClosePipeInput> input_acc(input.get());
  switch (input->which()) {


    case ::mojo::pipe_control::RunOrClosePipeInput::Tag::PEER_ASSOCIATED_ENDPOINT_CLOSED_EVENT:

      size += mojo::internal::PrepareToSerialize<::mojo::pipe_control::PeerAssociatedEndpointClosedEventPtr>(
          *(input_acc.data()->peer_associated_endpoint_closed_event), context);

      break;

    case ::mojo::pipe_control::RunOrClosePipeInput::Tag::ASSOCIATED_ENDPOINT_CLOSED_BEFORE_SENT_EVENT:

      size += mojo::internal::PrepareToSerialize<::mojo::pipe_control::AssociatedEndpointClosedBeforeSentEventPtr>(
          *(input_acc.data()->associated_endpoint_closed_before_sent_event), context);

      break;
    default:
      break;
  }
  return size;
}

// static
void UnionSerializerImpl<::mojo::pipe_control::RunOrClosePipeInputPtr>::Serialize(
    ::mojo::pipe_control::RunOrClosePipeInputPtr& input,
    Buffer* buf,
    ::mojo::pipe_control::internal::RunOrClosePipeInput_Data** output,
    bool inlined,
    SerializationContext* context) {
  ::mojo::pipe_control::internal::RunOrClosePipeInput_Data* result = *output;
  if (input) {
    if (!inlined)
      result = ::mojo::pipe_control::internal::RunOrClosePipeInput_Data::New(buf);
    UnionAccessor<::mojo::pipe_control::RunOrClosePipeInput> input_acc(input.get());
    // TODO(azani): Handle unknown and objects.
    // Set the not-null flag.
    result->size = 16;
    result->tag = input->which();
    switch (input->which()) {
      case ::mojo::pipe_control::RunOrClosePipeInput::Tag::PEER_ASSOCIATED_ENDPOINT_CLOSED_EVENT: {
        mojo::internal::Serialize<::mojo::pipe_control::PeerAssociatedEndpointClosedEventPtr>(
            *(input_acc.data()->peer_associated_endpoint_closed_event), buf,
            &result->data.f_peer_associated_endpoint_closed_event.ptr, context);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            !result->data.f_peer_associated_endpoint_closed_event.ptr,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null peer_associated_endpoint_closed_event in RunOrClosePipeInput union");
        break;
      }
      case ::mojo::pipe_control::RunOrClosePipeInput::Tag::ASSOCIATED_ENDPOINT_CLOSED_BEFORE_SENT_EVENT: {
        mojo::internal::Serialize<::mojo::pipe_control::AssociatedEndpointClosedBeforeSentEventPtr>(
            *(input_acc.data()->associated_endpoint_closed_before_sent_event), buf,
            &result->data.f_associated_endpoint_closed_before_sent_event.ptr, context);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            !result->data.f_associated_endpoint_closed_before_sent_event.ptr,
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null associated_endpoint_closed_before_sent_event in RunOrClosePipeInput union");
        break;
      }
    }
  } else if (inlined) {
    result->set_null();
  } else {
    result = nullptr;
  }
  *output = result;
}

// static
bool UnionSerializerImpl<::mojo::pipe_control::RunOrClosePipeInputPtr>::Deserialize(
    ::mojo::pipe_control::internal::RunOrClosePipeInput_Data* input,
    ::mojo::pipe_control::RunOrClosePipeInputPtr* output,
    SerializationContext* context) {
  bool success = true;
  if (input && !input->is_null()) {
    ::mojo::pipe_control::RunOrClosePipeInputPtr result(::mojo::pipe_control::RunOrClosePipeInput::New());
    UnionAccessor<::mojo::pipe_control::RunOrClosePipeInput> result_acc(result.get());
    switch (input->tag) {
      case ::mojo::pipe_control::RunOrClosePipeInput::Tag::PEER_ASSOCIATED_ENDPOINT_CLOSED_EVENT: {
        result_acc.SwitchActive(::mojo::pipe_control::RunOrClosePipeInput::Tag::PEER_ASSOCIATED_ENDPOINT_CLOSED_EVENT);
        if (!mojo::internal::Deserialize<::mojo::pipe_control::PeerAssociatedEndpointClosedEventPtr>(
                input->data.f_peer_associated_endpoint_closed_event.ptr,
                result_acc.data()->peer_associated_endpoint_closed_event, context))
          success = false;
        break;
      }
      case ::mojo::pipe_control::RunOrClosePipeInput::Tag::ASSOCIATED_ENDPOINT_CLOSED_BEFORE_SENT_EVENT: {
        result_acc.SwitchActive(::mojo::pipe_control::RunOrClosePipeInput::Tag::ASSOCIATED_ENDPOINT_CLOSED_BEFORE_SENT_EVENT);
        if (!mojo::internal::Deserialize<::mojo::pipe_control::AssociatedEndpointClosedBeforeSentEventPtr>(
                input->data.f_associated_endpoint_closed_before_sent_event.ptr,
                result_acc.data()->associated_endpoint_closed_before_sent_event, context))
          success = false;
        break;
      }
    }
    *output = std::move(result);
  } else {
    output->reset();
  }
  return success;
}

}  // namespace internal

}  // namespace mojo


#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif