// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef MOJO_PUBLIC_INTERFACES_BINDINGS_PIPE_CONTROL_MESSAGES_MOJOM_H_
#define MOJO_PUBLIC_INTERFACES_BINDINGS_PIPE_CONTROL_MESSAGES_MOJOM_H_

#include <stdint.h>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/strings/string_piece.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/control_message_proxy.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map.h"
#include "mojo/public/cpp/bindings/message_filter.h"
#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/native_struct.h"
#include "mojo/public/cpp/bindings/no_interface.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/interfaces/bindings/pipe_control_messages.mojom-internal.h"
#include "mojo/public/cpp/bindings/array.h"
#include "mojo/public/cpp/bindings/string.h"
namespace mojo {
namespace pipe_control {

const uint32_t kRunOrClosePipeMessageId = 0xFFFFFFFEU;
class RunOrClosePipeMessageParams;
class RunOrClosePipeMessageParamsDataView;
using RunOrClosePipeMessageParamsPtr = mojo::StructPtr<RunOrClosePipeMessageParams>;

class PeerAssociatedEndpointClosedEvent;
class PeerAssociatedEndpointClosedEventDataView;
using PeerAssociatedEndpointClosedEventPtr = mojo::InlinedStructPtr<PeerAssociatedEndpointClosedEvent>;

class AssociatedEndpointClosedBeforeSentEvent;
class AssociatedEndpointClosedBeforeSentEventDataView;
using AssociatedEndpointClosedBeforeSentEventPtr = mojo::InlinedStructPtr<AssociatedEndpointClosedBeforeSentEvent>;

class RunOrClosePipeInput;

typedef mojo::StructPtr<RunOrClosePipeInput> RunOrClosePipeInputPtr;




class PeerAssociatedEndpointClosedEvent {
 public:
  using DataView = PeerAssociatedEndpointClosedEventDataView;
  using Data_ = internal::PeerAssociatedEndpointClosedEvent_Data;

  static PeerAssociatedEndpointClosedEventPtr New();

  template <typename U>
  static PeerAssociatedEndpointClosedEventPtr From(const U& u) {
    return mojo::TypeConverter<PeerAssociatedEndpointClosedEventPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PeerAssociatedEndpointClosedEvent>::Convert(*this);
  }

  PeerAssociatedEndpointClosedEvent();
  ~PeerAssociatedEndpointClosedEvent();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PeerAssociatedEndpointClosedEventPtr>
  PeerAssociatedEndpointClosedEventPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, PeerAssociatedEndpointClosedEvent>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static mojo::Array<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        PeerAssociatedEndpointClosedEventPtr, mojo::Array<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(mojo::Array<uint8_t> input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        PeerAssociatedEndpointClosedEventPtr, mojo::Array<uint8_t>>(
            std::move(input), output);
  }

  uint32_t id;
};

class PeerAssociatedEndpointClosedEventDataView {
 public:
  PeerAssociatedEndpointClosedEventDataView(
      internal::PeerAssociatedEndpointClosedEvent_Data* data,
      mojo::internal::SerializationContext* context);
  uint32_t id() const;
 private:
  internal::PeerAssociatedEndpointClosedEvent_Data* data_;
  mojo::internal::SerializationContext* context_;
};



class AssociatedEndpointClosedBeforeSentEvent {
 public:
  using DataView = AssociatedEndpointClosedBeforeSentEventDataView;
  using Data_ = internal::AssociatedEndpointClosedBeforeSentEvent_Data;

  static AssociatedEndpointClosedBeforeSentEventPtr New();

  template <typename U>
  static AssociatedEndpointClosedBeforeSentEventPtr From(const U& u) {
    return mojo::TypeConverter<AssociatedEndpointClosedBeforeSentEventPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AssociatedEndpointClosedBeforeSentEvent>::Convert(*this);
  }

  AssociatedEndpointClosedBeforeSentEvent();
  ~AssociatedEndpointClosedBeforeSentEvent();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AssociatedEndpointClosedBeforeSentEventPtr>
  AssociatedEndpointClosedBeforeSentEventPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, AssociatedEndpointClosedBeforeSentEvent>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static mojo::Array<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        AssociatedEndpointClosedBeforeSentEventPtr, mojo::Array<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(mojo::Array<uint8_t> input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        AssociatedEndpointClosedBeforeSentEventPtr, mojo::Array<uint8_t>>(
            std::move(input), output);
  }

  uint32_t id;
};

class AssociatedEndpointClosedBeforeSentEventDataView {
 public:
  AssociatedEndpointClosedBeforeSentEventDataView(
      internal::AssociatedEndpointClosedBeforeSentEvent_Data* data,
      mojo::internal::SerializationContext* context);
  uint32_t id() const;
 private:
  internal::AssociatedEndpointClosedBeforeSentEvent_Data* data_;
  mojo::internal::SerializationContext* context_;
};



class RunOrClosePipeInput {
 public:
  using Data_ = internal::RunOrClosePipeInput_Data;
  using Tag = Data_::RunOrClosePipeInput_Tag;

  static RunOrClosePipeInputPtr New();

  template <typename U>
  static RunOrClosePipeInputPtr From(const U& u) {
    return mojo::TypeConverter<RunOrClosePipeInputPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, RunOrClosePipeInput>::Convert(*this);
  }

  RunOrClosePipeInput();
  ~RunOrClosePipeInput();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename UnionPtrType = RunOrClosePipeInputPtr>
  RunOrClosePipeInputPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, RunOrClosePipeInput>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  Tag which() const {
    return tag_;
  }


  bool is_peer_associated_endpoint_closed_event() const;
  PeerAssociatedEndpointClosedEventPtr& get_peer_associated_endpoint_closed_event() const;
  void set_peer_associated_endpoint_closed_event(PeerAssociatedEndpointClosedEventPtr peer_associated_endpoint_closed_event);
  bool is_associated_endpoint_closed_before_sent_event() const;
  AssociatedEndpointClosedBeforeSentEventPtr& get_associated_endpoint_closed_before_sent_event() const;
  void set_associated_endpoint_closed_before_sent_event(AssociatedEndpointClosedBeforeSentEventPtr associated_endpoint_closed_before_sent_event);

 private:
  friend class mojo::internal::UnionAccessor<RunOrClosePipeInput>;
  union Union_ {
    Union_() {}
    ~Union_() {}
    PeerAssociatedEndpointClosedEventPtr* peer_associated_endpoint_closed_event;
    AssociatedEndpointClosedBeforeSentEventPtr* associated_endpoint_closed_before_sent_event;
  };
  void SwitchActive(Tag new_active);
  void SetActive(Tag new_active);
  void DestroyActive();
  Tag tag_;
  Union_ data_;
};


class RunOrClosePipeMessageParams {
 public:
  using DataView = RunOrClosePipeMessageParamsDataView;
  using Data_ = internal::RunOrClosePipeMessageParams_Data;

  static RunOrClosePipeMessageParamsPtr New();

  template <typename U>
  static RunOrClosePipeMessageParamsPtr From(const U& u) {
    return mojo::TypeConverter<RunOrClosePipeMessageParamsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, RunOrClosePipeMessageParams>::Convert(*this);
  }

  RunOrClosePipeMessageParams();
  ~RunOrClosePipeMessageParams();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = RunOrClosePipeMessageParamsPtr>
  RunOrClosePipeMessageParamsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, RunOrClosePipeMessageParams>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static mojo::Array<uint8_t> Serialize(UserType* input) {
    return mojo::internal::StructSerializeImpl<
        RunOrClosePipeMessageParamsPtr, mojo::Array<uint8_t>>(input);
  }

  template <typename UserType>
  static bool Deserialize(mojo::Array<uint8_t> input,
                          UserType* output) {
    return mojo::internal::StructDeserializeImpl<
        RunOrClosePipeMessageParamsPtr, mojo::Array<uint8_t>>(
            std::move(input), output);
  }

  RunOrClosePipeInputPtr input;
};

class RunOrClosePipeMessageParamsDataView {
 public:
  RunOrClosePipeMessageParamsDataView(
      internal::RunOrClosePipeMessageParams_Data* data,
      mojo::internal::SerializationContext* context);
  bool ReadInput(RunOrClosePipeInputPtr* value);
 private:
  internal::RunOrClosePipeMessageParams_Data* data_;
  mojo::internal::SerializationContext* context_;
};




template <typename UnionPtrType>
RunOrClosePipeInputPtr RunOrClosePipeInput::Clone() const {
  // Use UnionPtrType to prevent the compiler from trying to compile this
  // without being asked.
  UnionPtrType rv(New());
  switch (tag_) {
    case Tag::PEER_ASSOCIATED_ENDPOINT_CLOSED_EVENT:
      rv->set_peer_associated_endpoint_closed_event(mojo::internal::Clone(*data_.peer_associated_endpoint_closed_event));
      break;
    case Tag::ASSOCIATED_ENDPOINT_CLOSED_BEFORE_SENT_EVENT:
      rv->set_associated_endpoint_closed_before_sent_event(mojo::internal::Clone(*data_.associated_endpoint_closed_before_sent_event));
      break;
  };
  return rv;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, RunOrClosePipeInput>::value>::type*>
bool RunOrClosePipeInput::Equals(const T& other) const {
  if (tag_ != other.which())
    return false;

  switch (tag_) {
    case Tag::PEER_ASSOCIATED_ENDPOINT_CLOSED_EVENT:
      return mojo::internal::Equals(*(data_.peer_associated_endpoint_closed_event), *(other.data_.peer_associated_endpoint_closed_event));
    case Tag::ASSOCIATED_ENDPOINT_CLOSED_BEFORE_SENT_EVENT:
      return mojo::internal::Equals(*(data_.associated_endpoint_closed_before_sent_event), *(other.data_.associated_endpoint_closed_before_sent_event));
  };

  return false;
}
template <typename StructPtrType>
RunOrClosePipeMessageParamsPtr RunOrClosePipeMessageParams::Clone() const {
  // Use StructPtrType to prevent the compiler from trying to compile this
  // without being asked.
  StructPtrType rv(New());
  rv->input = mojo::internal::Clone(input);
  return rv;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, RunOrClosePipeMessageParams>::value>::type*>
bool RunOrClosePipeMessageParams::Equals(const T& other) const {
  if (!mojo::internal::Equals(this->input, other.input))
    return false;
  return true;
}
template <typename StructPtrType>
PeerAssociatedEndpointClosedEventPtr PeerAssociatedEndpointClosedEvent::Clone() const {
  // Use StructPtrType to prevent the compiler from trying to compile this
  // without being asked.
  StructPtrType rv(New());
  rv->id = mojo::internal::Clone(id);
  return rv;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, PeerAssociatedEndpointClosedEvent>::value>::type*>
bool PeerAssociatedEndpointClosedEvent::Equals(const T& other) const {
  if (!mojo::internal::Equals(this->id, other.id))
    return false;
  return true;
}
template <typename StructPtrType>
AssociatedEndpointClosedBeforeSentEventPtr AssociatedEndpointClosedBeforeSentEvent::Clone() const {
  // Use StructPtrType to prevent the compiler from trying to compile this
  // without being asked.
  StructPtrType rv(New());
  rv->id = mojo::internal::Clone(id);
  return rv;
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, AssociatedEndpointClosedBeforeSentEvent>::value>::type*>
bool AssociatedEndpointClosedBeforeSentEvent::Equals(const T& other) const {
  if (!mojo::internal::Equals(this->id, other.id))
    return false;
  return true;
}
}  // namespace pipe_control
}  // namespace mojo

namespace mojo {


template <>
struct StructTraits<::mojo::pipe_control::RunOrClosePipeMessageParams, ::mojo::pipe_control::RunOrClosePipeMessageParamsPtr> {
  static bool IsNull(const ::mojo::pipe_control::RunOrClosePipeMessageParamsPtr& input) { return !input; }
  static void SetToNull(::mojo::pipe_control::RunOrClosePipeMessageParamsPtr* output) { output->reset(); }
  static decltype(::mojo::pipe_control::RunOrClosePipeMessageParams::input)& input(
      ::mojo::pipe_control::RunOrClosePipeMessageParamsPtr& input) {
    return input->input;
  }

  static bool Read(::mojo::pipe_control::RunOrClosePipeMessageParamsDataView input, ::mojo::pipe_control::RunOrClosePipeMessageParamsPtr* output);
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::mojo::pipe_control::RunOrClosePipeMessageParamsPtr, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::mojo::pipe_control::RunOrClosePipeMessageParams, UserType>;

  static size_t PrepareToSerialize(MaybeConstUserType& input,
                                   SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return 0;

    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    ALLOW_UNUSED_LOCAL(custom_context);

    size_t size = sizeof(::mojo::pipe_control::internal::RunOrClosePipeMessageParams_Data);
    decltype(CallWithContext(Traits::input, input, custom_context)) in_input = CallWithContext(Traits::input, input, custom_context);
    size += mojo::internal::PrepareToSerialize<::mojo::pipe_control::RunOrClosePipeInputPtr>(
        in_input, true, context);
    return size;
  }

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::mojo::pipe_control::internal::RunOrClosePipeMessageParams_Data** output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input)) {
      *output = nullptr;
      return;
    }

    void* custom_context = CustomContextHelper<Traits>::GetNext(context);

    auto result =
          ::mojo::pipe_control::internal::RunOrClosePipeMessageParams_Data::New(buffer);
      decltype(CallWithContext(Traits::input, input, custom_context)) in_input = CallWithContext(Traits::input, input, custom_context);
      auto input_ptr = &result->input;
      mojo::internal::Serialize<::mojo::pipe_control::RunOrClosePipeInputPtr>(
          in_input, buffer, &input_ptr, true, context);
      MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
          result->input.is_null(),
          mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
          "null input in RunOrClosePipeMessageParams struct");
    *output = result;

    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::mojo::pipe_control::internal::RunOrClosePipeMessageParams_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::mojo::pipe_control::RunOrClosePipeMessageParamsDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


template <>
struct StructTraits<::mojo::pipe_control::PeerAssociatedEndpointClosedEvent, ::mojo::pipe_control::PeerAssociatedEndpointClosedEventPtr> {
  static bool IsNull(const ::mojo::pipe_control::PeerAssociatedEndpointClosedEventPtr& input) { return !input; }
  static void SetToNull(::mojo::pipe_control::PeerAssociatedEndpointClosedEventPtr* output) { output->reset(); }
  static decltype(::mojo::pipe_control::PeerAssociatedEndpointClosedEvent::id) id(
      const ::mojo::pipe_control::PeerAssociatedEndpointClosedEventPtr& input) {
    return input->id;
  }

  static bool Read(::mojo::pipe_control::PeerAssociatedEndpointClosedEventDataView input, ::mojo::pipe_control::PeerAssociatedEndpointClosedEventPtr* output);
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::mojo::pipe_control::PeerAssociatedEndpointClosedEventPtr, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::mojo::pipe_control::PeerAssociatedEndpointClosedEvent, UserType>;

  static size_t PrepareToSerialize(MaybeConstUserType& input,
                                   SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return 0;

    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    ALLOW_UNUSED_LOCAL(custom_context);

    size_t size = sizeof(::mojo::pipe_control::internal::PeerAssociatedEndpointClosedEvent_Data);
    return size;
  }

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::mojo::pipe_control::internal::PeerAssociatedEndpointClosedEvent_Data** output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input)) {
      *output = nullptr;
      return;
    }

    void* custom_context = CustomContextHelper<Traits>::GetNext(context);

    auto result =
          ::mojo::pipe_control::internal::PeerAssociatedEndpointClosedEvent_Data::New(buffer);
      result->id = CallWithContext(Traits::id, input, custom_context);
    *output = result;

    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::mojo::pipe_control::internal::PeerAssociatedEndpointClosedEvent_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::mojo::pipe_control::PeerAssociatedEndpointClosedEventDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


template <>
struct StructTraits<::mojo::pipe_control::AssociatedEndpointClosedBeforeSentEvent, ::mojo::pipe_control::AssociatedEndpointClosedBeforeSentEventPtr> {
  static bool IsNull(const ::mojo::pipe_control::AssociatedEndpointClosedBeforeSentEventPtr& input) { return !input; }
  static void SetToNull(::mojo::pipe_control::AssociatedEndpointClosedBeforeSentEventPtr* output) { output->reset(); }
  static decltype(::mojo::pipe_control::AssociatedEndpointClosedBeforeSentEvent::id) id(
      const ::mojo::pipe_control::AssociatedEndpointClosedBeforeSentEventPtr& input) {
    return input->id;
  }

  static bool Read(::mojo::pipe_control::AssociatedEndpointClosedBeforeSentEventDataView input, ::mojo::pipe_control::AssociatedEndpointClosedBeforeSentEventPtr* output);
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::mojo::pipe_control::AssociatedEndpointClosedBeforeSentEventPtr, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::mojo::pipe_control::AssociatedEndpointClosedBeforeSentEvent, UserType>;

  static size_t PrepareToSerialize(MaybeConstUserType& input,
                                   SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return 0;

    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    ALLOW_UNUSED_LOCAL(custom_context);

    size_t size = sizeof(::mojo::pipe_control::internal::AssociatedEndpointClosedBeforeSentEvent_Data);
    return size;
  }

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::mojo::pipe_control::internal::AssociatedEndpointClosedBeforeSentEvent_Data** output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input)) {
      *output = nullptr;
      return;
    }

    void* custom_context = CustomContextHelper<Traits>::GetNext(context);

    auto result =
          ::mojo::pipe_control::internal::AssociatedEndpointClosedBeforeSentEvent_Data::New(buffer);
      result->id = CallWithContext(Traits::id, input, custom_context);
    *output = result;

    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::mojo::pipe_control::internal::AssociatedEndpointClosedBeforeSentEvent_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::mojo::pipe_control::AssociatedEndpointClosedBeforeSentEventDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MojomType>
struct UnionSerializerImpl;

template <>
struct UnionSerializerImpl<::mojo::pipe_control::RunOrClosePipeInputPtr> {
  static size_t PrepareToSerialize(::mojo::pipe_control::RunOrClosePipeInputPtr& input,
                                   bool inlined,
                                   SerializationContext* context);

  static void Serialize(::mojo::pipe_control::RunOrClosePipeInputPtr& input,
                        Buffer* buffer,
                        ::mojo::pipe_control::internal::RunOrClosePipeInput_Data** output,
                        bool inlined,
                        SerializationContext* context);

  static bool Deserialize(::mojo::pipe_control::internal::RunOrClosePipeInput_Data* input,
                          ::mojo::pipe_control::RunOrClosePipeInputPtr* output,
                          SerializationContext* context);
};

template <typename MaybeConstUserType>
struct Serializer<::mojo::pipe_control::RunOrClosePipeInputPtr, MaybeConstUserType>
    : public UnionSerializerImpl<::mojo::pipe_control::RunOrClosePipeInputPtr> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;

  static_assert(std::is_same<MaybeConstUserType, UserType>::value,
                "Only support serialization of non-const Unions.");
  static_assert(std::is_same<UserType, ::mojo::pipe_control::RunOrClosePipeInputPtr>::value,
                "Custom mapping of mojom union is not supported.");
};

}  // namespace internal

}  // namespace mojo

#endif  // MOJO_PUBLIC_INTERFACES_BINDINGS_PIPE_CONTROL_MESSAGES_MOJOM_H_